/**
*
* Name: Center Msg Fix
* Version: 0.3 (01.11.2019)
* Author: mx?!
* Description: This plugin fixes '%s bug' for 'client_print() + print_center' on old clients,
*	caused by AMXX >= 5260 (1.9.0) or 5384 (1.10.0), and also fixes new line bug (lack of ^n)
*	for console_print()
*
* Thx to: fantom, present
*
* How to use: You need to add '#include <center_msg_fix>' to all
*	plugins that contain 'client_print() + print_center' or console_print()
*
* Changelog:
*	0.1 (24.10.2019) by mx?!:
*		* Release
*	0.2 (24.10.2019) by mx?!
*		* Improving usage
*	0.3	(01.11.2019) by mx?!:
*		* Added native 'CenterMsgFix_ConsolePrint'
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>
*
*/

new const PLUGIN_VERSION[] = "0.3"

/* -------------------- */

#include <amxmodx>
#include <center_msg_fix>

#define chx charsmax

new g_msgTextMsg

/* -------------------- */

public plugin_init() {
	register_plugin("Center Msg Fix", PLUGIN_VERSION, "mx?!")

	g_msgTextMsg = get_user_msgid("TextMsg")
}

/* -------------------- */

public plugin_natives() {
	register_native("CenterMsgFix_PrintMsg", "_CenterMsgFix_PrintMsg")
	register_native("CenterMsgFix_ConsolePrint", "_CenterMsgFix_ConsolePrint")
}

/* -------------------- */

public _CenterMsgFix_PrintMsg(iPluginID, iParamCount) {
	enum { player = 1, message_type, message, fmt_args }

	new pPlayer = get_param(player)

	if(pPlayer) {
		SetGlobalTransTarget(pPlayer)
	}

	new szMessage[191]
	vdformat(szMessage, chx(szMessage), message, fmt_args)

	message_begin(pPlayer ? MSG_ONE_UNRELIABLE : MSG_BROADCAST, g_msgTextMsg, .player = pPlayer)
	write_byte(get_param(message_type))
	write_string(szMessage)
	message_end()
}

/* -------------------- */

public _CenterMsgFix_ConsolePrint(iPluginID, iParamCount) {
	enum { player = 1, message, fmt_args }

	new pPlayer = get_param(player)

	if(pPlayer) {
		SetGlobalTransTarget(pPlayer)
	}

	new szMessage[191]
	vdformat(szMessage, chx(szMessage), message, fmt_args)

	if(!pPlayer) {
		server_print(szMessage)
	}
	else {
		add(szMessage, chx(szMessage), "^n")

		message_begin(MSG_ONE_UNRELIABLE, g_msgTextMsg, .player = pPlayer)
		write_byte(print_console)
		write_string(szMessage)
		message_end()
	}
}